// EditBoxView.cpp : implementation of the CEditBoxView class
//

#include "stdafx.h"
#include "EditBox.h"

#include "EditBoxDoc.h"
#include "EditBoxView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditBoxView

IMPLEMENT_DYNCREATE(CEditBoxView, CView)

BEGIN_MESSAGE_MAP(CEditBoxView, CView)
	//{{AFX_MSG_MAP(CEditBoxView)
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_WM_TIMER()
	ON_WM_KEYDOWN()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditBoxView construction/destruction

CEditBoxView::CEditBoxView()
{
	// TODO: add construction code here

	m_clFont.CreateFont(
		12,                        // nHeight
		0,                         // nWidth
		0,                         // nEscapement
		0,                         // nOrientation
		FW_NORMAL,                 // nWeight
		FALSE,                     // bItalic
		FALSE,                     // bUnderline
		0,                         // cStrikeOut
		ANSI_CHARSET,              // nCharSet
		OUT_DEFAULT_PRECIS,        // nOutPrecision
		CLIP_DEFAULT_PRECIS,       // nClipPrecision
		DEFAULT_QUALITY,           // nQuality
		DEFAULT_PITCH | FF_SWISS,  // nPitchAndFamily
		"ü");                 // lpszFacename

	//  о ͸ Ѵ.
	CFile clFile;

	clFile.Open( "data.txt", CFile::modeRead );
	m_pcBuffer = ( char* ) malloc( MAX_DATA_LENGTH );
	clFile.Read( m_pcBuffer, MAX_DATA_LENGTH );
	if( MAX_DATA_LENGTH > clFile.GetLength() )
	{
		m_iDataLength = clFile.GetLength();
	}
	else
	{
		m_iDataLength = MAX_DATA_LENGTH;
	}
	clFile.Close();
	m_clPen.CreatePen( PS_SOLID, 2, RGB( 255, 0, 0 ) );


	// Ʒ ʿ κ
	m_bLButtonDown = FALSE;
	m_iCurLine = 0;
	m_iCursorX = 0;
	m_iCursorY = 0;
	//    WIDTH ؾ ϴµ ׽Ʈ ̷ ߴ.
	m_iMaxCharCountInLine = SCREEN_WIDTH / ENG_FONT_WIDTH;
	//    WIDTH ؾ ϴµ ׽Ʈ ̷ ߴ.
	m_iMaxLineCount = SCREEN_HEIGHT / FONT_HEIGHT;
}

void CEditBoxView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	m_bLButtonDown = FALSE;
	CView::OnLButtonUp(nFlags, point);
}

void CEditBoxView::OnMouseMove(UINT nFlags, CPoint point) 
{
	if( m_bLButtonDown == TRUE )
	{
		//  ũ  
		if( m_clPoint.y > point.y + 20 )
		{
			if( ScrollUp( ( m_clPoint.y - point.y ) / 20 ) == TRUE )
			{
				Invalidate();
			}
			m_clPoint = point;
		}
		// Ʒ ũ  
		else if( m_clPoint.y + 20 < point.y )
		{
			if( ScrollDown( ( point.y - m_clPoint.y ) / 20 ) == TRUE ) 
			{
				Invalidate();
			}
			m_clPoint = point;
		}
		TRACE( "Line = %d\n", m_iCurLine );
	}
	CView::OnMouseMove(nFlags, point);
}

void CEditBoxView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	m_bLButtonDown = TRUE;
	m_clPoint = point;
	//m_iCurLine++;
	//Invalidate();
	TRACE( "Line Number = %d\n", m_iCurLine );
	CView::OnLButtonDown(nFlags, point);
}

void CEditBoxView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	m_iCurLine--;
	Invalidate();
	TRACE( "Line Number = %d\n", m_iCurLine );

	CView::OnRButtonDown(nFlags, point);
}

//=============================================================================

CEditBoxView::~CEditBoxView()
{
}

BOOL CEditBoxView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CEditBoxView drawing

void CEditBoxView::OnDraw(CDC* pDC)
{
	CEditBoxDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDC->SelectObject( &m_clFont );
	pDC->SelectObject( &m_clPen );

	// TODO: add draw code for native data here
	MyPaint( pDC );

}

/////////////////////////////////////////////////////////////////////////////
// CEditBoxView printing

BOOL CEditBoxView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CEditBoxView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CEditBoxView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CEditBoxView diagnostics

#ifdef _DEBUG
void CEditBoxView::AssertValid() const
{
	CView::AssertValid();
}

void CEditBoxView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CEditBoxDoc* CEditBoxView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CEditBoxDoc)));
	return (CEditBoxDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEditBoxView message handlers

/**
	ȭ鿡 ׷ִ κ
*/
void CEditBoxView::MyPaint( CDC* pDC )
{
	int iPos;

	// LCD ġ ׸.
	pDC->Rectangle( -1, -1, SCREEN_WIDTH + 1, SCREEN_HEIGHT + 1);

	if( FindLine( m_iCurLine, &iPos ) == TRUE )
	{
		PrintData( pDC, m_pcBuffer + iPos, m_iDataLength - iPos - 1 );
		TRACE( " ȣ [%d]\n", m_iCurLine );
	}
	else
	{
		TRACE( "ش  ã  ϴ. [%d]\n", m_iCurLine );
	}
	// Ŀ ׸. 
	DrawCursor( pDC );
}

/**
	ۿ ִ ͸  ŭ ȭ鿡 ѷִ κ
*/
void CEditBoxView::PrintData( CDC* pDC, char* pcData, int iCount )
{
	int i;
	char vcHanBuffer[ 2 ];

	m_iCurCharX = 0;
	m_iCurCharY = 0;

	for( i = 0 ; i < iCount ; i++ )
	{
		//   ڿ̸ Űش.
		if( ( i + 1 < iCount ) && ( IsNewLine( pcData + i ) == TRUE ) )
		{
			//   Ѱ?
			if( IsEnoughSpaceToNewLine( 1 ) == TRUE )
			{
				MoveToNextLine();
				i++;
			}
			else
			{
				break;
			}
		}
		else
		{
			//  ѱ̸ ѱ Ѵ.
			if( ( i + 1 < iCount ) && ( IsHangul( pcData + i ) == TRUE ) )
			{
				//  ѱ ؾϴµ ڿ     ش.
				if( IsEnoughSpaceToPrint( 2 ) == FALSE )
				{
					//   Ѱ?
					if( IsEnoughSpaceToNewLine( 1 ) == TRUE )
					{
						MoveToNextLine();
					}
					else
					{
						break;
					}
				}

				// Ѵ.
				vcHanBuffer[ 0 ] = pcData[ i ];
				vcHanBuffer[ 1 ] = pcData[ i + 1 ];

				pDC->TextOut( m_iCurCharX * ENG_FONT_WIDTH, m_iCurCharY * FONT_HEIGHT, 
					vcHanBuffer, 2 );

				m_iCurCharX += 2;
				i++;
			}
			else
			{
				//   ڸ ؾϴµ ڿ     ش.
				if( IsEnoughSpaceToPrint( 1 ) == FALSE )
				{
					//   Ѱ?
					if( IsEnoughSpaceToNewLine( 1 ) == TRUE )
					{
						MoveToNextLine();
					}
					else
					{
						break;
					}
				}

				pDC->TextOut( m_iCurCharX * ENG_FONT_WIDTH, m_iCurCharY * FONT_HEIGHT, pcData + i, 1 );
				m_iCurCharX++;
			}
		}
	}
}

/**
	 ġ Char Count ŭ   ִ ȮѴ.
*/
BOOL CEditBoxView::IsEnoughSpaceToPrint( int iPrintCharCount )
{
	if( IsValidRangeForCharX( m_iCurCharX + iPrintCharCount - 1 ) == FALSE )
	{
		return FALSE;
	}
	return TRUE;
}

/**
	 ٷ  ̵Ѵ.
*/
void CEditBoxView::MoveToNextLine( void )
{
	m_iCurCharY++;
	m_iCurCharX = 0;
}

/**
	 ġ New Line Count ŭ   ִ ȮѴ.
*/
BOOL CEditBoxView::IsEnoughSpaceToNewLine( int iNewLineCount )
{
	if( IsValidRangeForCharY( m_iCurCharY + iNewLineCount ) == FALSE )
	{
		return FALSE;
	}
	return TRUE;
}

/**
	N° Line ġ piStartPosition Ѱش.
*/
BOOL CEditBoxView::FindLine( int iLineIndex, int* piStartPosition )
{
	int i;
	m_iCurCharX = 0;
	m_iCurCharY = 0;

	if( iLineIndex == 0 )
	{
		*piStartPosition = 0;
		return TRUE;
	}

	// Ʈ ۸  󰡸鼭 ش Line ã´.
	for( i = 0 ; i < m_iDataLength ; i++ )
	{
		//   ڿ̸ Űش.
		if( ( i + 1 < m_iDataLength ) && ( IsNewLine( m_pcBuffer + i ) == TRUE ) )
		{
			MoveToNextLine();

			//   ѹ ġϸ .
			if( IsCurCharYMatch( iLineIndex ) == TRUE )
			{
				*piStartPosition = i + 2;
				return TRUE;
			}

			i++;
		}
		else
		{
			//  ѱ̸ ѱ Ѵ.
			if( ( i + 1 < m_iDataLength ) && ( IsHangul( m_pcBuffer + i ) == TRUE ) )
			{
				//  ѱ ؾϴµ ڿ     ش.
				if( IsEnoughSpaceToPrint( 2 ) == FALSE )
				{
					MoveToNextLine();

					//   ѹ ġϸ .
					if( IsCurCharYMatch( iLineIndex ) == TRUE )
					{
						*piStartPosition = i;
						return TRUE;
					}
				}
				m_iCurCharX += 2;
				i++;
			}
			else
			{
				//   ڸ ؾϴµ ڿ     ش.
				if( IsEnoughSpaceToPrint( 1 ) == FALSE )
				{
					MoveToNextLine();

					//   ѹ ġϸ .
					if( IsCurCharYMatch( iLineIndex ) == TRUE )
					{
						*piStartPosition = i;
						return TRUE;
					}
				}
				m_iCurCharX++;
			}
		}
	}
	return FALSE;
}

/**
	   ȣ iLineIndexΰ?
*/
BOOL CEditBoxView::IsCurCharYMatch( int iLineNubmer )
{
	if( m_iCurCharY == iLineNubmer )
	{
		return TRUE;
	}
	return FALSE;
}

/**
	 ġ Ŀ ׸.
*/
void CEditBoxView::DrawCursor( CDC* pDC )
{
	pDC->MoveTo( m_iCursorX * ENG_FONT_WIDTH, m_iCursorY * FONT_HEIGHT );
	pDC->LineTo( m_iCursorX * ENG_FONT_WIDTH, ( m_iCursorY + 1 ) * FONT_HEIGHT );
}

/**
	Ŀ ̵ ó
*/
void CEditBoxView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	int iBeforeLine;

	switch( nChar )
	{
	case VK_LEFT:
		MoveCursorLeft();
		Invalidate();
		break;

	case VK_RIGHT:
		MoveCursorRight();
		Invalidate();
		break;

	case VK_UP:
		MoveCursorUp();
		Invalidate();
		break;

	case VK_DOWN:
		MoveCursorDown();
		Invalidate();
		break;

	default:
		//  BackSpace Ű̸  Ŀ ű ش.
		if( nChar == VK_BACK )
		{
			iBeforeLine = m_iCursorY + m_iCurLine;

			if( MoveCursorLeft() == TRUE )
			{
				DeleteCharactor( m_iCursorX, m_iCursorY + m_iCurLine );

				if( iBeforeLine != m_iCursorY + m_iCurLine )
				{
					//MoveCursorLeft();
				}
			}
		}
		// Enter ̸  ڷ ġȯ ش.
		else if( nChar == VK_RETURN )
		{
			AddString( m_iCursorX, m_iCursorY + m_iCurLine, "\r\n" );
			MoveCursorDown();
			m_iCursorX = 0;
		}
		// ׽Ʈ Ƴ ڵ
		else if( ( ( nChar >= 'A' ) && ( nChar <= 'Z' ) ) ||
				 ( nChar == VK_SPACE ) )
		{
			AddCharactor( m_iCursorX, m_iCursorY + m_iCurLine, nChar );
			MoveCursorRight();
		}
		Invalidate();
		break;
	}
	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}

/**
	Ŀ  δ.
*/
BOOL CEditBoxView::MoveCursorLeft( void )
{
	int iCharCountOfUpperLine;

	if( m_iCursorX > 0 )
	{
		m_iCursorX--;
		return TRUE;
	}
	else if( ( m_iCursorX == 0 ) && ( m_iCursorY > 0 ) )
	{
		m_iCursorY--;
		
		// ű   Charactor   Ŀ   ǥѴ.
		if( GetCharCountInLine( m_iCurLine + m_iCursorY, 
			&iCharCountOfUpperLine ) == FALSE )
		{
			return FALSE;
		}
		m_iCursorX = iCharCountOfUpperLine - 1;
		return TRUE;
	}
	//else if( ( m_iCursorX == 0 ) && ( m_iCursorY == 0 ) )
	else
	{
		if( m_iCurLine == 0 )
		{
			return FALSE;
		}
		else
		{
			m_iCurLine--;

			// ű   Charactor   Ŀ   ǥѴ.
			if( GetCharCountInLine( m_iCurLine + m_iCursorY, 
				&iCharCountOfUpperLine ) == FALSE )
			{
				return FALSE;
			}
			m_iCursorX = iCharCountOfUpperLine - 1;
			return TRUE;
		}
	}
	return FALSE;
}

/**
	Ŀ  δ.
*/
BOOL CEditBoxView::MoveCursorRight( void )
{
	int iCharCountOfCurLine;

	//  ο ִ  Charactor      ǴѴ.
	if( GetCharCountInLine( m_iCurLine + m_iCursorY, &iCharCountOfCurLine ) == 
		FALSE )
	{
		return FALSE;
	}

	if( m_iCursorX < iCharCountOfCurLine - 1 )
	{
		m_iCursorX++;
		return TRUE;
	}
	else if( ( m_iCursorX == iCharCountOfCurLine - 1 ) && 
		     ( IsValidRangeForCharY( m_iCursorY + 1 ) == TRUE ) )
	{
		//    ϴ°?
		if( GetCharCountInLine( m_iCurLine + m_iCursorY + 1, &iCharCountOfCurLine ) == 
			FALSE )
		{
			return FALSE;
		}

		m_iCursorY++;
		m_iCursorX = 0;
		return TRUE;
	}
	//  ȭ ũؾϴ ̸ ٷ   縦 .
	else if( ( m_iCursorX == iCharCountOfCurLine - 1 ) && 
		     ( m_iCursorY == m_iMaxLineCount - 1 ) )
	{
		//   ϴ°?
		if( GetCharCountInLine( m_iCurLine + m_iCursorY + 1, &iCharCountOfCurLine ) == 
			FALSE )
		{
			return FALSE;
		}

		m_iCurLine++;
		m_iCursorX = 0;
		return TRUE;
	}
	else
	{
		m_iCurLine++;
		m_iCursorX = 0;
		return TRUE;
	}
	return FALSE;
}

/**
	Ŀ Ʒ δ.
*/
BOOL CEditBoxView::MoveCursorDown( void )
{
	int iCharCountOfUnderLine;
	int iTempCursorY;
	int iTempCurLine;

	iTempCursorY = m_iCursorY;
	iTempCurLine = m_iCurLine;

	// Ŀ Ʒ .
	if( IsValidRangeForCharY( m_iCursorY + 1 ) == TRUE )
	{
		iTempCursorY++;
	}
	else
	{
		iTempCurLine++;
	}

	//  ο  Charactor   CursorX Ͽ  ش.
	if( GetCharCountInLine( iTempCurLine + iTempCursorY, &iCharCountOfUnderLine ) == 
		FALSE )
	{
		return FALSE;
	}
	
	m_iCursorY = iTempCursorY;
	m_iCurLine = iTempCurLine;

	if( m_iCursorX > iCharCountOfUnderLine - 1 )
	{
		m_iCursorX = iCharCountOfUnderLine - 1;
	}

	return TRUE;
}

/**
	Ŀ  δ.
*/
BOOL CEditBoxView::MoveCursorUp( void )
{
	int iCharCountOfUpperLine;

	// Ŀ  ĭ ø.
	if( m_iCursorY > 0 )
	{
		m_iCursorY--;
	}
	else
	{
		if( m_iCurLine > 0 )
		{
			m_iCurLine--;
		}
		else
		{
			return FALSE;
		}
	}

	// ű  Charactor   CursorX Ͽ  ش.
	if( GetCharCountInLine( m_iCurLine + m_iCursorY, &iCharCountOfUpperLine ) == 
		FALSE )
	{
		return FALSE;
	}

	if( m_iCursorX > iCharCountOfUpperLine - 1 )
	{
		m_iCursorX = iCharCountOfUpperLine - 1;
	}

	return TRUE;
}

/**
	ش Line Index Char Count ´.
*/
BOOL CEditBoxView::GetCharCountInLine( int iLineIndex, int* piCharCount )
{
	int iStartPosition;
	int i;

	if( FindLine( iLineIndex, &iStartPosition ) == FALSE )
	{
		return FALSE;
	}

	for( i = 0 ; ( i + iStartPosition < m_iDataLength ) && 
		         ( i < m_iMaxCharCountInLine ) ; i++ )
	{
		//  ѱ̶ ڿ   ؾѴ.
		if( ( i + iStartPosition + 1 < m_iDataLength ) &&
			( IsHangul( m_pcBuffer + i + iStartPosition ) == TRUE ) )
		{
			if( IsValidRangeForCharX( i + 1 ) == FALSE )
			{
				*piCharCount = i;
				return TRUE;
			}
			i++;
		}
		else if( ( m_pcBuffer[ i + iStartPosition ] == '\r' ) &&
			( i + iStartPosition + 1 < m_iDataLength ) &&
			( m_pcBuffer[ i + iStartPosition + 1 ] == '\n' ) )
		{
			*piCharCount = i + 1;
			return TRUE;
		}
	}
	*piCharCount = i;
	return TRUE;
}

/**
	ش ڰ New Line ΰ ǴѴ.
		ݵ pcBuffer 2Byte ̻̾ Ѵ.
*/
BOOL CEditBoxView::IsNewLine( char* pcBuffer )
{
	if( ( pcBuffer[ 0 ] == '\r' ) && ( pcBuffer[ 1 ] == '\n' ) )
	{
		return TRUE;
	}
	return FALSE;
}

/**
	ش ڰ ѱΰ ǴѴ.
		ݵ pcBuffer 2Byte ̻̾ Ѵ.
*/
BOOL CEditBoxView::IsHangul( char* pcBuffer )
{
	if( ( ( pcBuffer[ 0 ] & 0x80 ) == 0x80 ) && 
		( ( pcBuffer[ 1 ] & 0x80 ) == 0x80 ) )
	{
		return TRUE;
	}
	return FALSE;
}

/**
	ش Column, Line cData  ߰Ѵ.
*/
BOOL CEditBoxView::AddCharactor( int iColumn, int iLine, char cData )
{
	char vcBuffer[ 2 ];

	vcBuffer[ 0 ] = cData;
	vcBuffer[ 1 ] = '\0';

	return AddString( iColumn, iLine, vcBuffer );
}

/**
	ش Column, Line Buffer  Ѵ.
*/
BOOL CEditBoxView::AddString( int iColumn, int iLine, char* pcBuffer )
{
	int iLinePos;
	int iLength;
	int iCopyLength;

	if( IsValidRangeForCharX( iColumn ) == FALSE )
	{
		return FALSE;
	}

	if( FindLine( iLine, &iLinePos ) == FALSE )
	{
		return FALSE;
	}

	iLength = strlen( pcBuffer );

	//  Ʈ ߰ߴµ  ִ ũ⸦ ѰԵǸ  ó ش.
	if( m_iDataLength + iLength >= MAX_DATA_LENGTH )
	{
		iCopyLength = m_iDataLength - iLinePos - iColumn - iLength + 1 -
			( m_iDataLength + iLength - MAX_DATA_LENGTH );
		m_iDataLength = MAX_DATA_LENGTH;
	}
	else
	{
		iCopyLength = m_iDataLength - iLinePos - iColumn - iLength + 1;
		m_iDataLength += iLength;
	}

	//  Copy Length 0 ۴ٸ ׳ .
	if( iCopyLength < 0 )
	{
		return FALSE;
	}

	memcpy( m_pcBuffer + iLinePos + iColumn + iLength, m_pcBuffer + iLinePos + 
		iColumn, iCopyLength );
	memcpy( m_pcBuffer + iLinePos + iColumn, pcBuffer, iLength );

	return TRUE;
}	

/**
	ش Column, Line ڸ .
*/
BOOL CEditBoxView::DeleteCharactor( int iColumn, int iLine )
{
	int iLinePos;
	int iLength;

	if( IsValidRangeForCharX( iColumn ) == FALSE )
	{
		return FALSE;
	}

	if( FindLine( iLine, &iLinePos ) == FALSE )
	{
		return FALSE;
	}
	
	//    ϴ ڰ ๮̸ 2 ش.
	if( IsNewLine( m_pcBuffer + iLinePos + iColumn ) == TRUE )
	{
		iLength = 2;
	}
	else if ( ( iColumn - 1 >= 0 ) &&
		      ( IsNewLine( m_pcBuffer + iLinePos + iColumn - 1 ) == TRUE ) )
	{
		iColumn--;
		iLength = 2;
	}
	else
	{
		iLength = 1;
	}

	// ڿ ܼ  ش.
	memcpy( m_pcBuffer + iLinePos + iColumn, m_pcBuffer + iLinePos + 
		iColumn + iLength, m_iDataLength - iLinePos - iColumn - iLength );
	
	m_iDataLength -= iLength;
	return TRUE;
}	

/**
	Scroll Down Ų.
*/
BOOL CEditBoxView::ScrollDown( int iLineCount )
{
	int iTemp;

	if( GetCharCountInLine( m_iCurLine + iLineCount, &iTemp ) == FALSE )
	{
		return FALSE;
	}

	m_iCurLine++;
	
	// ࿡ ũҶ Ŀ   Ŀ  ó Ѵ.
	//  ܼ Cursor X 0 .
	if( IsValidRangeForCharY( m_iCursorY - 1 ) == TRUE )
	{
		m_iCursorY--;
	}
	else
	{
		m_iCursorX = 0;
	}
	return TRUE;
}

/**
	Scroll Up Ų.
*/
BOOL CEditBoxView::ScrollUp( int iLineCount )
{
	if( m_iCurLine <= 0 )
	{
		return FALSE;
	}

	m_iCurLine--;
	// ࿡ ũҶ Ŀ   Ŀ  ó Ѵ.
	//  ܼ Cursor X 0 .
	if( IsValidRangeForCharY( m_iCursorY + 1 ) == TRUE )
	{
		m_iCursorY++;
	}
	else
	{
		m_iCursorX = 0;
	}
	return TRUE;
}

/**
	Charactor ϱ X ǥ ȿѰ ǴѴ.
		 ȭ鿡 ִ ° X  ̿ؼ ǴѴ.
*/
BOOL CEditBoxView::IsValidRangeForCharX( int iX )
{
	if( ( iX >= 0 ) && ( iX < m_iMaxCharCountInLine ) )
	{
		return TRUE;
	}
	return FALSE;
}

/**
	Charactor ϱ X ǥ ȿѰ ǴѴ.
		 ȭ鿡 ִ ° X  ̿ؼ ǴѴ.
*/
BOOL CEditBoxView::IsValidRangeForCharY( int iY )
{
	if( ( iY >= 0 ) && ( iY < m_iMaxLineCount ) )
	{
		return TRUE;
	}
	return FALSE;
}
